<i18n lang="yml">
en:
  problem_location: "Problem location"
  attention_location: "Attention location"
  other_location: "No ABP location"
  scan_time: "Time of scan"
  item_cardboard: "Pieces of cardboard"
  item_bags: "Residual waste (trash bags)"
  item_bulky: "Pieces of bulky waste"
  urgency: "Urgency"
  high: "High"
  medium: "Medium"
  low: "Low"
nl:
  problem_location: "Probleemlocatie"
  attention_location: "Aandachtslocatie"
  other_location: "Geen ABP-locatie"
  scan_time: "Tijdstip scan"
  item_cardboard: "Stukken karton"
  item_bags: "Vuilniszakken"
  item_bulky: "Stukken grofvuil"
  urgency: "Urgentie"
  high: "Hoog"
  medium: "Middel"
  low: "Laag"
</i18n>

<template>
  <AmsTableGroup
    ref="tBody"
    :class="$style['scans-tbody']"
    :style="`height: ${tBodyHeight}`"
  >
    <template v-if="STATE.loaded.scans">
      <template v-for="(row, rIndex) of rows">
        <AmsTableRow
          :key="rIndex"
          :data-cluster-id="row.cluster_location.subValue.properties.remote_id"
          :data-location="row.cluster_location.value"
          :data-coordinates="row.cluster_location.subValue.geometry.coordinates"
          :is-actionable="true"
          :has-shadow="true"
          :class="[
            foldoutState.openedFoldout === row.cluster_location.subValue.properties.remote_id ? $style['is-open'] : null,
            foldoutState.markerHighlighted[0] === row.cluster_location.subValue.properties.remote_id ? $style['is-highlighted'] : null,
          ]"
          tabindex="0"
          @keydown.enter.native="openFoldout(row.cluster_location, $event)"
          @keydown.space.native="openFoldout(row.cluster_location, $event)"
          @click.capture.native="openFoldout(row.cluster_location, $event)"
          @mouseover.native="highlight(row.cluster_location, $event)"
        >
          <!-- First contentless cell in row with foldout icon -->
          <template v-if="foldableRows">
            <AmsTableCell :class="$style['cell-foldout']" style="width: 2rem;">
              <span :class="[$style['icon'], $style['icon-foldout'], foldoutState.openedFoldout === row.cluster_location.subValue.properties.remote_id ? $style['is-open'] : null]">
                <SvgArrowheadRight width="32" height="32" />
              </span>
            </AmsTableCell>
          </template>

          <!-- Content cells -->
          <template v-for="(cell, cIndex) of Object.values(row).filter(cell => typeof cell.id !== 'undefined')">
            <AmsTableCell
              v-show="!cell.isHidden"
              :key="cIndex"
              :ref="cell.id"
              :class="[
                $style['table-cell'],
                $style[`cell-${cell.id}`],
                enableViewOptions && STATE.rightPanelOpen && includesHideableColumns[cell.id] ? 'opacity-0 x2l:table-cell x2l:opacity-1' : null,
              ]"
              :style="enableViewOptions && STATE.rightPanelOpen && includesHideableColumns[cell.id] ? 'padding-inline: 0px; width: 0px;' : null"
            >
              <div
                :data-urgency-lvl="cell.id === 'urgency' ? Math.floor(cell.value) : null"
                :class="[
                  $style['content'],
                  $style[cell.id],
                ]"
              >
                <template v-if="cell.id === 'urgency'">
                  <div :title="`${$t(cell.id)}: ${$t(URGENCY_LEVELS[Math.floor(cell.value)]).toLowerCase()}`">
                    <div :class="$style['dot']" /> {{ $t(URGENCY_LEVELS[Math.floor(cell.value)]) }}
                  </div>
                </template>
                <template v-else-if="cell.id === 'last_scan'">
                  <span :title="`${$t('scan_time')}: ${dateTime.fromISO(cell.value).toFormat('HH:mm, cccc DD')}`">
                    {{ dateTime.fromISO(cell.value).toFormat("HH:mm") }}
                  </span>
                </template>
                <template v-else>
                  <span :title="`${typeof cell.value === 'number' ? `${$t(cell.id)}: ` : ''}${$t(String(cell.value))}`">
                    {{ $t(String(cell.value)) }}
                  </span>
                </template>
              </div>
            </AmsTableCell>
          </template>
        </AmsTableRow>

        <!-- Collapsible rows with additional information on the row above it -->
        <template v-if="foldableRows">
          <transition :key="`${rIndex}x`" name="zap-h">
            <AmsScansTableRowFoldout
              v-if="((foldoutState.openedFilters && tGIndex === 0) || foldoutState.openedFoldout === row.cluster_location.subValue.properties.remote_id)"
              :colspan="Object.keys(row).length"
              :cells="row"
              :hide-columns="enableViewOptions && STATE.rightPanelOpen"
              :class="$style['foldout']"
            />
          </transition>
        </template>

        <!-- Empty rows for layout purposes as `tr` elements cannot have margin's. -->
        <AmsTableRow
          :key="`empty_row_${rIndex}x`"
          :is-empty="true"
        >
          <td :colspan="numberOfCells" />
        </AmsTableRow>
      </template>
    </template>

    <!-- Loading rows indicators -->
    <template v-else>
      <template v-for="row of 15">
        <AmsTableRowLoading :key="row" />
        <AmsTableRow :key="`empty_${row}`" :is-empty="true">
          <td />
        </AmsTableRow>
      </template>
    </template>

    <tr>
      <td :colspan="numberOfCells" style="background-color: transparent;">
        <slot name="endrow" />
      </td>
    </tr>
  </AmsTableGroup>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  inject,
  onMounted,
  ref,
  watch,
  watchEffect,
} from "@nuxtjs/composition-api";
import { debounce, throttle } from "lodash";
import { DateTime } from "luxon";
import useRowFoldout from "~/composables/row-foldout";
import useScansPrep from "~/components/Views/Operational/composables/scans-prep";
import useSorting from "~/composables/sorting";

export default defineComponent({
  name: "AmsScansTable",

  components: {
    AmsTableGroup: () => import("~/components/_elements/Table/TableGroup.vue"),
    AmsTableRow: () => import("~/components/_elements/Table/TableRow.vue"),
    AmsTableRowLoading: () => import("~/components/_elements/Table/TableRowLoading.vue"),
    AmsTableCell: () => import("~/components/_elements/Table/TableCell.vue"),
    AmsScansTableRowFoldout: () => import("./ScansTableRowFoldout.vue"),
    // @ts-ignore
    SvgArrowheadRight: () => import("~/assets/img/ui/arrowhead-right.svg"),
  },

  props: {
    rows: {
      type: Array,
      default: () => [],
    },
    tGIndex: {
      type: Number,
      required: true,
    },
    foldableRows: {
      type: Boolean,
      default: false,
    },
    enableViewOptions: {
      type: Boolean,
      required: true,
    },
  },

  setup (props) {
    const { STATE } = inject("store");
    const { foldoutState } = useRowFoldout();
    const { includesHideableColumns } = useScansPrep();

    const dateTime = ref(DateTime);

    const URGENCY_LEVELS = ["none", "low", "low", "low", "medium", "high"];

    const numberOfCells = computed(() => props.rows[0] ? Object.keys(props.rows[0]).length : 1);

    /**
     * Fold open an info box under a row.
     * @param { object } location object.
     * @param { object } event - Click event.
     */
    function openFoldout (location, $event): void {
      $event.preventDefault();

      if (typeof location.value === "undefined") {
        foldoutState.openedFilters = null;
      } else {
        foldoutState.openedFoldout = foldoutState.openedFoldout === location.subValue.properties.remote_id ? null : location.subValue.properties.remote_id;
      }
    }

    /**
     * Highlight row and corresponding marker.
     * @param { object } location object.
     * @param { object } event - Click event.
     */
    function highlight (location): void {
      if (typeof location.value === "undefined") {
        foldoutState.rowHighlighted = null;
      } else {
        foldoutState.rowHighlighted = foldoutState.rowHighlighted === location.subValue.properties.remote_id ? null : location.subValue.properties.remote_id;
      }
    }

    const tBody = ref(null);
    const tBodyHeight = ref("56vh");

    /**
     * Set the tBody height so that it stretches to the bottom of the screen.
     */
    function setBodyHeight () {
      if (tBody.value?.$el) {
        tBodyHeight.value = `${(window.innerHeight - tBody.value.$el.getBoundingClientRect().y) - 32}px`;
      }
    }

    const stopWatchTBody = watchEffect(() => {
      if (tBody.value?.$el) {
        foldoutState.tBody = tBody.value;

        setBodyHeight();

        stopWatchTBody();
      }
    });

    onMounted(() => {
      const { sort } = useSorting();

      window.addEventListener("resize", throttle(setBodyHeight, 1000));

      sort();
    });

    watch(
      () => foldoutState.openedFilters,
      debounce((newValue) => {
        if (newValue) {
          foldoutState.openedFoldout = null;
          setBodyHeight();
        } else {
          setTimeout(setBodyHeight, 500);
        }
      }, 500, {
        leading: false,
        trailing: true,
      }),
    );

    return {
      STATE,
      dateTime,
      foldoutState,
      includesHideableColumns,
      URGENCY_LEVELS,
      numberOfCells,
      openFoldout,
      highlight,
      tBody,
      tBodyHeight,
    };
  },
});
</script>

<style lang="postcss" module>
.scans-tbody {
  transition: height 500ms ease-out;
  height: 56vh;

  @apply overflow-y-scroll;

  tr.foldout {
    @apply relative;
  }

  tr {
    &:hover,
    &[data-focus-visible-added] {
      & ~ tr.foldout {
        @apply outline-none;

        & > td {
          transition: border-color 250ms ease, box-shadow 250ms ease;
          border-color: #e6e6e6;
          box-shadow: 0 4px 0 0 rgba(0, 0, 0, 0.1);
        }
      }
    }
  }

  .table-cell {
    transition:
      width 250ms ease,
      opacity 250ms ease,
    ;

    @apply p-2 bg-white align-top;

    &.cell-last_scan {
      width: 85px;
    }

    &.cell-cluster_location {
      width: 100%;
      min-width: 180px;
    }

    &.cell-quarter,
    &.cell-area,
    &.cell-location_type {
      width: 150px;
    }

    &.cell-item_cardboard,
    &.cell-item_bags,
    &.cell-item_bulky {
      width: 75px;
    }

    &.cell-urgency {
      width: 120px;
    }

    &:first-of-type {
      @apply rounded-l-sm;
    }

    &:last-of-type {
      @apply rounded-r-sm;
    }

    .content {
      @apply block py-2 h-8 overflow-hidden;

      & > span {
        @apply inline-flex w-full;
      }

      &.cell-foldout {
        padding-right: 0;
      }

      &.cell-last_scan {
        width: inherit;
      }

      &.cluster_location,
      &.quarter,
      &.area,
      &.location_type {
        text-overflow: ellipsis;
        white-space: nowrap;

        @apply pr-4;

        & > span {
          @apply inline;
        }
      }

      &.cluster_location {
        width: inherit;
        min-width: inherit;

        @apply pr-2 font-medium;
      }

      &.quarter,
      &.area,
      &.location_type {
        width: inherit;
      }

      &.item_cardboard,
      &.item_bags,
      &.item_bulky {
        width: inherit;
      }

      &.urgency {
        padding-top: 7px;
        padding-bottom: 6px;

        @apply rounded-sm mr-4 pl-2 pr-1 font-medium;

        & > div {
          @apply flex items-center;
        }

        &[data-urgency-lvl="0"] {
          @apply bg-gray-400 text-gray-900;
        }

        &[data-urgency-lvl="1"] {
          @apply bg-green-300 text-green-800;
        }

        &[data-urgency-lvl="2"] {
          @apply bg-green-300 text-green-800;
        }

        &[data-urgency-lvl="3"] {
          @apply bg-green-300 text-green-800;
        }

        &[data-urgency-lvl="4"] {
          @apply bg-orange-300 text-orange-800;
        }

        &[data-urgency-lvl="5"] {
          @apply bg-red-300 text-red-800;
        }

        .dot {
          transform: translateY(-1px);
          background-color: currentColor;
          size: 0.675em;

          @apply rounded-full mr-2;
        }
      }
    }
  }
}

.icon {
  transition: transform 250ms ease;

  @apply flex justify-center items-center;

  svg {
    width: 14px;
    height: 14px;
  }
}

.icon-foldout {
  @apply mt-3 text-gray-700;

  &.is-open {
    transform: rotate(90deg);
  }
}
</style>
